typedef char __flash * STR;

// 
#define WIN_SIZE 128
// - TCB
#define MAX_TCB	2
//  TCB
typedef struct
{
 char dotx; // 
 char state; // 
 unsigned long RIP; // IP 
 //TCP 
 unsigned int lport; //  (  )
 unsigned int rport; // 
 unsigned long SEQ; //    
 unsigned long ACK; //  
 union
 {
  char CTL; //
  struct
  {
   char FIN:1,
        SYN:1,
        RST:1,
        PSH:1,
        _ACK:1,
        F5:1,
        F6:1,
        F7:1;
  };
 };
 unsigned int wsize; //  
 unsigned int INCACK; //   ACK  
 unsigned int INCSEQ; //   SEQ  
 unsigned int LENS; //-  
 unsigned int rxp; //  . 
 unsigned int rxf; //. . 
 unsigned int txp; //  
 unsigned int txf; //.  
 char txb[WIN_SIZE]; // 
 char rxb[WIN_SIZE]; // 
} T_TCB;

//  TCB
#define CLOSED		0
#define LISTEN		1
#define SYN_SENT	2
#define SYN_RECIVED	3
#define ESTABLISHED	4
#define CLOSE		5
#define FIN_WAIT_1	6
#define FIN_WAIT_2	7
#define CLOSE_WAIT	8
#define CLOSING		9
#define LAST_ACK	10
#define	TIME_WAIT	11

// , ip0-ip3 -  
void TCP_init(char ip0, char ip1, char ip2, char ip3);
//    ,   port
//   
//  
T_TCB *TCPlisten(unsigned int port);
// 
__z void TCPclose(T_TCB *tcb);
// 
__z int TCPgetc(T_TCB *tcb);
// 
__z void TCPputc(T_TCB * tcb, char c);
//   
__x_z void TCPputs_P(T_TCB * tcb,STR p);

