#include "iom128.h"
#include "inavr.h"
#include "mtos.h"
#include "pgmspace.h"
#include "stdio.h"
#include "tcpip.h"

SEMA s1;

__task void Task1(void)
{
 CON_TASK_HEADER(8,64,1);
 char c=32;
 for(;;)
 {
   putchar(c);
   c++;
   if (!c) c=32;
 }
}

__task void main(void)
{
 unsigned int s=0;
 InitMTOS();
 SetupTimeDateCorrection(10);
 SetupTimeDateCorrection(-10);
 TCP_init(192,168,0,232);
 printf_P((PGM_P)"System started.\n");
 CreateTask(Task1);
 for(;;)
 {
  //putchar(getchar());
  printf_P((PGM_P)"Allocate sema...\n");
  AllocSema(&s1);
  //__delay_cycles(10000);
  printf_P((PGM_P)"Free sema...    \n");
  FreeSema(&s1);
  printf_P((PGM_P)"Step %d done...    \n",s);
  s++;
 }
}
